# liste.spec
# Specification algebrique des listes
# Auteur : VOURIOT Thierry
# Date : 27 novembre 2001

# Sorte S definissant l'egalite
spec EG etend BASE

	sorte S

	operations

		==: S S -> Bool		#Egalite
		!=: S S -> Bool		#Difference

	axiomes

		(x==x) = vrai
		(x!=y) = non (x==y)

fspec

spec LISTE(EG) etend BASE

	sorte Liste

	operations

		listenouv: -> Liste	#Creation d'une liste vide
		adjt: Liste S -> Liste	#Adjonction en tete
		suppt: Liste -> Liste	#Suppression en tete
		tete: Liste -> S	#Tete
		vide: Liste -> Bool	#Teste si la liste est vide
		lgr: Liste -> Nat	#Longueur (nbre d'elements)
		

	preconditions 

		pre suppt(l) = non vide(l)
		pre tete(l) = non vide(l)
		

	axiomes 
		#Constructeurs listenouv et adjt

		suppt(adjt(l,x)) = l

		tete(adjt(l,x)) = x

		vide(listenouv) = vrai
		vide(adjt(l,x)) = faux

		lgr(listenouv) = 0
		lgr(adjt(l,x)) = lgr(l) + 1

fspec

spec LISTE1(EG) etend LISTE(EG)

	operations

		queue: Liste -> S
		adjq: Liste S -> Liste
		suppq: Liste -> Liste
		conc: Liste Liste -> Liste
		lig: Liste Nat -> Liste
		lid: Liste Nat -> Liste
		supp: Liste Nat -> Liste
		chg: Liste Nat S -> Liste
		ins: Liste Nat S -> Liste
		rech: Liste S -> Nat
		decd: Liste -> Liste
		decg: Liste -> Liste


	preconditions 

		...


	axiomes 
		#Constructeurs 
		
		...

fspec
