/* liste_flavius.c
 * Fichier source de l'implantation des fonctions pour la liste de Flavius
 * Auteur : VOURIOT Thierry
 * Date : 27 octobre 2001
 */
#include "liste_flavius.h"

/* Creation d'une nouvelle liste */
Liste listenouv(void) {
	
	Liste l=NULL;
	return l;
}

/* Adjonction en queue */
Liste adjq(Liste list, Nat x) {

	Liste l1 = MALLOC(SListe);
	l1->v = x;
	
	if (list != NULL) {
		l1->s = list->s;
		list->s = l1;	
	
	}
	else {
		l1->s = l1;
	}
	return l1;
}

/* Suppression en tete */
Liste supt(Liste l) {
	
	Liste tmp = l->s;
	l->s = l->s->s;
	free(tmp);
	return l;
}

/* Decalage circulaire vers la gauche */
Liste decg(Liste l) {

	return l->s;
}
	
	
	
/* Tete */
Nat tete(Liste l) {

	return l->s->v;
}	

/* Construction d'une liste d'entier de 1 a 40 */
Liste constl40() {

	Liste l = listenouv();
	int i;
	
	for (i=1;i<41;i++)
		l = adjq(l,i);
	
	return l;
}

/* 6*Decalage circulaire vers la gauche */
Liste decag6(Liste l) {

	Liste lres = l;
	int i;
	
	for (i=1;i<7;i++)
		lres = decg(lres);
	
	return lres;
}

/* Renvoie l'entier de Flavius
 * On prend une liste d'entier de 1 a 40, on avance de 7 dans la liste
 * et supprime l'entier, on continue jusqu'a ce qu'il ne reste plus
 * q'un nombre
 */
Nat flavius() {

	Liste l = constl40();
	int i;
	
	for (i=1;i<41;i++) {
        aff(l);
		l = supt(decag6(l));
    }
		
	return tete(l);
}

/* Affiche la liste a l'ecran */
void aff(Liste l)
{
       Liste queue = l;
       printf("%d ",tete(l));
       for (l=decg(l);queue != l;l=decg(l))
                printf("%d ",tete(l));
       printf("\n");
}

/* Programme de test */
int main() {
    printf("Flavius : %d\n",flavius());
}
