/* liste_flavius.h
 * Fichier en tete pour l'implantation de la liste de Flavius
 * Auteur : VOURIOT Thierry
 * Date : 31 octobre 2001
 */

#include "base.h"

/* Entiers naturels */
typedef unsigned short Nat;
/* Booleens */
typedef unsigned char Bool;

/* Definition de la structure des listes */
typedef struct sListe
{
	Nat v;
	struct sListe *s;
} SListe, *Liste;

/* Creation d'une nouvelle liste */
extern Liste listenouv(void);

/* Adjonction en tete */
extern Liste adjt(Liste, Nat);

/* Adjonction en queue */
extern Liste adjq(Liste, Nat);

/* Suppression en tete */
extern Liste supt(Liste);

/* Tete */
extern Nat tete(Liste);

/* Teste si la liste est vide */
extern Bool vide(Liste);

/* Longueur (nombre d'elements) */
extern Nat lgr(Liste);

/* Adjonction en queue */
extern Liste adjq(Liste, Nat);

/* Decalage circulaire vers la gauche */
extern Liste decg(Liste);

/* Copie */
extern Liste copie(Liste);

/* Construction d'une liste d'entier de 1 a 40 */
extern Liste constl40(void);

/* 6*Decalage circulaire vers la gauche */
extern Liste decag6(Liste);

/* Renvoie l'entier de Flavius
 * On prend une liste d'entier de 1 a 40, on avance de 7 dans la liste
 * et supprime l'entier, on continue jusqu'a ce qu'il ne reste plus
 * qu'un nombre
 */
extern Nat flavius(void);

/* Affiche la liste a l'ecran */
extern void aff(Liste l);
